Bug 1900491 - When scaling replicas to zero, Octavia loadbalancer pool members are not updated accordingly
Summary: When scaling replicas to zero, Octavia loadbalancer pool members are not upda...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Networking
Version: 3.11.0
Hardware: x86_64
OS: Linux
high
high
Target Milestone: ---
: 4.5.z
Assignee: Luis Tomas Bolivar
QA Contact: GenadiC
URL:
Whiteboard:
Depends On: 1898950
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-11-23 07:56 UTC by Luis Tomas Bolivar
Modified: 2020-12-15 20:28 UTC (History)
8 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1898950
Environment:
Last Closed: 2020-12-15 20:28:46 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github openshift kuryr-kubernetes pull 413 0 None open Bug 1900491: Ensure members are deleted from pools when there is no endpoints 2020-11-30 07:23:32 UTC
Red Hat Product Errata RHSA-2020:5359 0 None None None 2020-12-15 20:28:59 UTC

Comment 2 rlobillo 2020-12-04 09:06:56 UTC
Verified on OCP4.5.0-0.nightly-2020-12-03-035613 over OSP13 with Amphora provider (2020-11-13.1).

creating a deployment with 3 replicas and service with below files:

$ cat demo_deployment.yaml 
apiVersion: apps/v1
kind: Deployment
metadata:
  name: demo
  labels:
    app: demo
spec:
  replicas: 3
  selector:
    matchLabels:
      app: demo
  template:
    metadata:
      labels:
        app: demo
    spec:
      containers:
      - name: demo
        image: kuryr/demo
        ports:
        - containerPort: 8080

$ cat demo_svc.yaml 
apiVersion: v1
kind: Service
metadata:
  name: demo
labels:
  app: demo
spec:
  selector:                  
    app: demo
  ports:
  - port: 80
    protocol: TCP
    targetPort: 8080

The result:

$ oc get all
NAME                        READY   STATUS              RESTARTS   AGE
pod/demo-68d74c645c-5szcs   1/1     Running             0          12s
pod/demo-68d74c645c-jwrfx   1/1     Running             0          12s
pod/demo-68d74c645c-mx4ts   0/1     Running             0          12s

NAME                   READY   UP-TO-DATE   AVAILABLE   AGE
deployment.apps/demo   3/3     3            3           12s

NAME                              DESIRED   CURRENT   READY   AGE
replicaset.apps/demo-68d74c645c   3         3         3       12s

and

$ openstack loadbalancer show test/demo                                                                                                                    
+---------------------+--------------------------------------+
| Field               | Value                                |
+---------------------+--------------------------------------+
| admin_state_up      | True                                 |
| created_at          | 2020-12-04T08:37:55                  |
| description         |                                      |
| flavor_id           | None                                 |
| id                  | 9503fca4-012b-4f97-909a-3bb1aa8fed3e |
| listeners           | fdcbab1d-e863-40fd-9639-3e4c5746f4c5 |
| name                | test/demo                            |
| operating_status    | ONLINE                               |
| pools               | e412aef1-332f-4319-a7c8-5054b4e6171b |
| project_id          | 123a3a6190174ec8856abe1f3db227d3     |
| provider            | amphora                              |
| provisioning_status | ACTIVE                               |
| updated_at          | 2020-12-04T08:39:37                  |
| vip_address         | 172.30.120.246                       |
| vip_network_id      | 975f9f19-23da-448b-acc9-25efd3c0de12 |
| vip_port_id         | 999695e0-aee5-43b7-ac7f-67d7edabf741 |
| vip_qos_policy_id   | None                                 |
| vip_subnet_id       | 98994eb3-2c85-45e6-9fc9-d0da0faf45ae |
+---------------------+--------------------------------------+

$ openstack loadbalancer member list e412aef1-332f-4319-a7c8-5054b4e6171b                                                                                  
+--------------------------------------+---------------------------------+----------------------------------+---------------------+----------------+---------------+------------------+-------
-+
| id                                   | name                            | project_id                       | provisioning_status | address        | protocol_port | operating_status | weight
 |
+--------------------------------------+---------------------------------+----------------------------------+---------------------+----------------+---------------+------------------+-------
-+
| 2dfcdf18-ea94-40b8-bcf6-89ef679af709 | test/demo-68d74c645c-jwrfx:8080 | 123a3a6190174ec8856abe1f3db227d3 | ACTIVE              | 10.128.115.120 |          8080 | NO_MONITOR       |      1
 |
| cfd37ca1-aaa3-43e8-8deb-884b5199ef83 | test/demo-68d74c645c-5szcs:8080 | 123a3a6190174ec8856abe1f3db227d3 | ACTIVE              | 10.128.115.237 |          8080 | NO_MONITOR       |      1
 |
| 16414e1f-2dcf-4171-a174-b7a80a8651c4 | test/demo-68d74c645c-mx4ts:8080 | 123a3a6190174ec8856abe1f3db227d3 | ACTIVE              | 10.128.114.76  |          8080 | NO_MONITOR       |      1
 |
+--------------------------------------+---------------------------------+----------------------------------+---------------------+----------------+---------------+------------------+-------
-+

now, scaling to 0 with below command:

$ oc scale --replicas=0 deployment.apps/demo
deployment.apps/demo scaled

After a while, all the members are removed from the pool:

$ openstack loadbalancer member list e412aef1-332f-4319-a7c8-5054b4e6171b

(shiftstack) [stack@undercloud-0 ~]$

Comment 5 errata-xmlrpc 2020-12-15 20:28:46 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (Moderate: OpenShift Container Platform 4.5.23 security and bug fix update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2020:5359


Note You need to log in before you can comment on or make changes to this bug.